/***********************************************************/
/* WCPsimul: a Web Cache removal Policy simulation tool    */
/* Copyright (C) 1997 Nicolas Niclausse                    */
/*                                                         */
/* This program is free software; you can redistribute     */
/* it and/or modify it under the terms of the GNU General  */
/* Public License as published by the Free Software        */
/* Foundation; either version 2 of the License, or (at     */
/* your option) any later version.                         */
/*                                                         */
/* This program is distributed in the hope that it will    */
/* be useful, but WITHOUT ANY WARRANTY; without even the   */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE.  See the GNU General Public License */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 675 Mass Ave,    */
/* Cambridge, MA 02139, USA.                               */
/*                                                         */
/* For information, you can contact me at:                 */
/* Nicolas.Niclausse@sophia.inria.fr                       */
/***********************************************************/
//
// Classe de Hash_Table
//
// Nicolas Niclausse
// Last update: 27/03/98
// Date de cration:10/10/1996

#include "TTableau.h"
#include "Log_URL.h"
#include "Hash.h"
#include <iostream.h>
#include <Pix.h>
#include <String.h>
#include <DLList.h>

int Hash_table::search(Log_URL * & i)
  {
    int ind=hash_function(i->URL);
    Pix indice;

    if (table[ind].empty())
      {
	return 0;
      }
    else
      {
	indice=table[ind].first();
	while ((indice!=0)&&(table[ind](indice).URL != i->URL))
	  {
	    table[ind].next(indice);
	  }
	if(indice==0)
	  {
	    return 0;
	  }
	else
	  {
	    i=&table[ind](indice);
	    return 1;
	  }

      }
  }

Log_URL * Hash_table::insert(const Log_URL& i)
  {
    int ind=hash_function(i.URL);

    if (table[ind].empty())
      {
	table[ind].prepend(i);
      }
    else
      {
	table[ind].append(i);
      }
    return &table[ind].rear();
  }

void Hash_table::remove(String s)
  {
    int ind=hash_function(s);
    Pix indice;
    
    if (table[ind].empty())
      {
	cerr << "erreur1 remove sur une liste vide dans Hash_table::remove\n";
	cerr << s << "\n";
	exit(1);
      }
    else
      {
	indice=table[ind].first();
	while ((indice!=0)&&(table[ind](indice).URL != s))
	  {
	    table[ind].next(indice);
	  }
	if(indice==0) //ne devrait pas arriver vu le test precedent
	  {
 	    cerr << "erreur2 remove sur une liste vide dans Hash_table::remove\n";
 	    cerr << s << "\n";
	    exit(1);
	  }
	else
	  {
	    table[ind].del(indice);
	  }
      }
  }

int Hash_table::hash_function(String s)
{
  long j = s.length();
  int i,n;
  
  for (i = j / 2, n = 0; i < j; i++)
    n ^= 271 * (unsigned) s[i];
  i = n ^ (j * 271);
  i=(i < 0 ? -i : i);
  return (i % table.maxsize());
}

int hash_f(String s)
{
  long i,j = s.length();
  int n;
  
  for (i = j / 2, n = 0; i < j; i++)
    n ^= 271 * (unsigned) s[i];
  i = n ^ (j * 271);
  return i % HASH_SIZE;
}


