/***********************************************************/
/* WCPsimul: a Web Cache removal Policy simulation tool    */
/* Copyright (C) 1997 Nicolas Niclausse                    */
/*                                                         */
/* This program is free software; you can redistribute     */
/* it and/or modify it under the terms of the GNU General  */
/* Public License as published by the Free Software        */
/* Foundation; either version 2 of the License, or (at     */
/* your option) any later version.                         */
/*                                                         */
/* This program is distributed in the hope that it will    */
/* be useful, but WITHOUT ANY WARRANTY; without even the   */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE.  See the GNU General Public License */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 675 Mass Ave,    */
/* Cambridge, MA 02139, USA.                               */
/*                                                         */
/* For information, you can contact me at:                 */
/* Nicolas.Niclausse@sophia.inria.fr                       */
/***********************************************************/
//
// Classe de Log_URL_new
//
// Nicolas Niclausse
// Last update: 
// Date de cration:27/03/97


#ifndef LOG_URL_H
#define LOG_URL_H

#include <String.h>

class Log_URL
{
public:
  String URL;
  double date_first_ref;
  double date_last_ref; // format: elapsed time since 01/01/1970 in ms
  long size;
  double retrieve_time; // ms
  char persistent; // persistent document
  long frequency;
  double cost;
  double cost2;

  Log_URL()
  {
    URL="";
    date_first_ref=0;
    date_last_ref=0;
    size=0;
    retrieve_time=0;
    frequency=0;
    cost=0;
    cost2=0;
    persistent='n';
   };

  void print()
  {
    cerr << "URL="<< URL <<" \n";
    cerr << "size="<< size <<" \n";
    cerr << "frequency="<< frequency <<" \n";
    cerr << "persistent="<< persistent <<" \n";
    cerr << "date_first_ref="<< date_first_ref <<" \n";
    cerr << "date_last_ref ="<< date_last_ref <<" \n";
    cerr << "retrieve_time ="<< retrieve_time <<" \n";
  };
};

#endif



