// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _StringCoupleCHMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _StringCoupleCHMap_h 1

#include "String.Couple.Map.h"
#include "String.defs.h"

#ifndef _StringCoupleCHNode_h
#define _StringCoupleCHNode_h 1

struct StringCoupleCHNode
{
  String                hd;
  Couple                cont;
  StringCoupleCHNode*      tl;
                     StringCoupleCHNode();
                     StringCoupleCHNode(String& h, Couple& c, StringCoupleCHNode* t = 0);
                     ~StringCoupleCHNode();
};

inline StringCoupleCHNode::StringCoupleCHNode() {}

inline StringCoupleCHNode::StringCoupleCHNode(String& h, Couple& c, StringCoupleCHNode* t)
     : hd(h), cont(c), tl(t) {}

inline StringCoupleCHNode::~StringCoupleCHNode() {}

typedef StringCoupleCHNode* StringCoupleCHNodePtr;

#endif


class StringCoupleCHMap : public StringCoupleMap
{
protected:
  StringCoupleCHNode** tab;
  unsigned int   size;

public:
                StringCoupleCHMap(Couple& dflt,unsigned int sz=DEFAULT_INITIAL_CAPACITY);
                StringCoupleCHMap(StringCoupleCHMap& a);
                ~StringCoupleCHMap();

  Couple&          operator [] (String& key);

  void          del(String& key);

  Pix           first();
  void          next(Pix& i);
  String&          key(Pix i);
  Couple&          contents(Pix i);

  Pix           seek(String& key);
  int           contains(String& key);

  void          clear(); 
  int           OK();
};


inline StringCoupleCHMap::~StringCoupleCHMap()
{
  clear();
  delete tab;
}

inline int StringCoupleCHMap::contains(String& key)
{
  return seek(key) != 0;
}

inline String& StringCoupleCHMap::key(Pix p)
{
  if (p == 0) error("null Pix");
  return ((StringCoupleCHNode*)p)->hd;
}

inline Couple& StringCoupleCHMap::contents(Pix p)
{
  if (p == 0) error("null Pix");
  return ((StringCoupleCHNode*)p)->cont;
}

#endif
