/***********************************************************/
/* WCPsimul: a Web Cache removal Policy simulation tool    */
/* Copyright (C) 1996 Nicolas Niclausse                    */
/*                                                         */
/* This program is free software; you can redistribute     */
/* it and/or modify it under the terms of the GNU General  */
/* Public License as published by the Free Software        */
/* Foundation; either version 2 of the License, or (at     */
/* your option) any later version.                         */
/*                                                         */
/* This program is distributed in the hope that it will    */
/* be useful, but WITHOUT ANY WARRANTY; without even the   */
/* implied warranty of MERCHANTABILITY or FITNESS FOR A    */
/* PARTICULAR PURPOSE.  See the GNU General Public License */
/* for more details.                                       */
/*                                                         */
/* You should have received a copy of the GNU General      */
/* Public License along with this program; if not, write   */
/* to the Free Software Foundation, Inc., 675 Mass Ave,    */
/* Cambridge, MA 02139, USA.                               */
/*                                                         */
/* For information, you can contact me at:                 */
/* Nicolas.Niclausse@sophia.inria.fr                       */
/***********************************************************/
//
// Classe de Tableaux:  Descendant de la classe abstraite TVTableau<T>
//
// Nicolas Niclausse
// Date de cration:16/10/1995

#include "TVTableau.h"
#include <iostream.h>
#include <Pix.h>

#ifndef TTABLEAU_H
#define TTABLEAU_H

template<class T> class TTableau:public TVTableau<T>
{	
protected:
  T *tab;	
  long size;
public:	
    
  TTableau();          // Constructeur par dfaut
  TTableau(long);    // Constructeur
  TTableau(const TTableau<T>&); //Constructeur -> arguments de fonctions

  virtual  ~TTableau();         // Destructeur
  
  void operator = (const TTableau<T>&);
  T& operator []( long) const;

  long maxsize() const; //Retourne la taille du tableau
  void resize( long); //redimensionne le tableau
  void resize( long n, long m);// Enleve les el. de n a m
  void swap( long i, long j, long n);// swappe n eleements 
  void initialise(const T); // tous les elements du tableau prennent la valeur  s 
  void apply_fct(T f(T)); //applique la fonction f 
  void decalage(const long n); //decalage du vecteur de n indices

   void insert(const TTableau<T>& x,  long j); //on insert le tableau x a partir de l'indice j

   void insert(const TTableau<T>& x,  long a, long b);//on insert les b premiers elements du tableau x a partir de l'indice j

  void sort(int compar(T&,T&), long len);

//   friend  ostream& operator << (ostream& s, const TTableau<T>& v)
//   {
//     long i;
    
//     if (v.maxsize()>0)
//       for (i=0;i<v.maxsize();i++)
// 	s << v[i] << " ";
//     else
//       s << "NULL";
//     return s;
//   }
 };



#endif


